//+------------------------------------------------------------------+
//|                                                 SELL SECURE.mq4  |
//|                                            created by Kamil2079  |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
/*
This script is created for selling on EURUSD and GBPUSD pairs on 5min or 4h chart.

Lot size rule:
100pips = 1/10 of current AccountFreeMargin (for SL=50pips Maximum risk = 5%)
Warning: Calculated for account in GBP !!!

Rules used for 5min chart:
- SL is equal High from previous candle plus spread,
- If SL is smaller than MinSL than SL = MinSL,
- If SL is bigger than MaxSL than SL = MaxSL,
- First: Sell order = 50% of lot size, TP = 10pips,
- Second: Sell order = 50% of lot size, TP = 10pips. 

Rules used for 4h chart:
- SL is equal High from previous candle plus spread 
- If SL is smaller than MinSL than SL = MinSL,
 And now if SL is smaller than MaxSL send two orders:
- First: Sell order = 50% of lot size and TP = SL (cover possible losses),
- Second: Sell order = 50% of lot size and NO TP,
 else if SL is bigger than MaxSL make three orders in three stages:
- First:  Sell order = 20% of lot size, NO TP,
- Second: Limit sell pending order 30% higher, 40% of lot size, NO TP,
- Third:  Limit sell pending order 45% higher, 40% of lot size, TP 80% lower (cover possible losses).
*/

int start()
  {
   datetime expiration;
   int ticket,error;
   double MinSL,MaxSL,slippage,SL,TP,TP1,TP2,LotSize,LS,LS2,LS3,Price,diff,minSL,maxSL,HI,spread;
   
//---- Setting right values      

      //My lotsize rule: 100pips = 1/10 of current AccountFreeMargin (Maximum risk = 10%)
      LotSize = 0.01*MathRound(MarketInfo("GBPUSD",MODE_BID)*AccountFreeMargin()/100); // <== calculated for account in GBP !!!
      spread = MarketInfo(Symbol(),MODE_SPREAD) * Point;
      
      if(Symbol() == "EURUSD")
      {
         if(Period() == 5)       //<= 5min chart
         {
            MinSL = 10; 
            MaxSL = 15; 
            TP    = 10; 
            slippage = 4;
         }
         else                    //<= 4h chart or other
         {
            MinSL = 15; 
            MaxSL = 50; 
            slippage = 7;
         }
      }  
      else if(Symbol() == "GBPUSD")
      {
         if(Period() == 5)       //<= 5min chart
         {
            MinSL = 10; 
            MaxSL = 20; 
            TP    = 10; 
            slippage = 4;
         }
         else                    //<= 4h chart or other
         {
            MinSL = 15;
            MaxSL = 50; 
            slippage = 7;
         }
      }
      else
      {
         MessageBox("WRONG PAIR !!","Error");
         return(0);
      }      
      
      //Set right values for 5 digits platform.
      if(Digits == 5)
      {
         MinSL = MinSL * 10;
         MaxSL = MaxSL * 10;
         TP    = TP * 10;
      }
         
      minSL = Bid + MinSL*Point;
      maxSL = Bid + MaxSL*Point;
   
//---- SL & TP calculation   
      HI = High[1] + spread;
      if(HI>minSL) SL = HI;
      else         SL = minSL;
      
      if(Period() == 5)          //<= 5min chart
      {
         TP1 = Bid-TP*Point;
         TP2 = Bid-TP*Point;
      }
      else                       //<= 4h chart or other
      {
         TP1 = (SL - Bid)/Point;
         TP1 = Bid-TP1*Point;
       
         TP2 = 0;
      }
      
//---- Start order send 
      if(SL<maxSL || Period() == 5)    // If SL < max SL or we are on 5min chart, send two orders
      {
         LS = MathRound(LotSize*100*0.5)/100;        // 50% of LotSize
         if(LS == 0) LS = 0.01;
         RefreshRates(); 
         ticket=OrderSend(Symbol(),OP_SELL,LS,Bid,slippage,SL,TP1,"BUY-1",255,801,CLR_NONE);
         if(ticket<=0)
            {
               error=GetLastError();
               Print("Error: ",ErrorDescription(error));
               if(error==134)      MessageBox("Account balance is too low!"); 
               else if(error==135) MessageBox("Prices have changed above the slippage!");
               else MessageBox("Error: "+ErrorDescription(error));
               return(0);         
            }
         OrderPrint(); 
      
         LS = LotSize - LS;                          // rest of LotSize (~50%)
         if(LS == 0)
         {
            MessageBox("Account balance is too low!"); 
            return(0);
         }
         while(true)
         {
          RefreshRates(); 
          ticket=OrderSend(Symbol(),OP_SELL,LS,Bid,slippage,SL,TP2,"BUY-2",255,802,CLR_NONE);
          if(ticket<=0)
            {
               error=GetLastError();
               if(error==134)
                 {   
                   MessageBox("Account balance is too low!"); 
                   return(0);
                 }
               else if(error==135) Print("Error: Prices have changed above the slippage!");
               else                Print("Error: "+ErrorDescription(error));               
               //---- 2 seconds wait
               Sleep(2000);      
            }
           else break;
         }   
         OrderPrint(); 
         int i = (SL - Bid)*10000; 
         MessageBox("LotSize = "+LotSize+", SL = "+i+" pips","DONE");  
      }
      
      
//---- If SL > 50pips, three orders in three stages
      else     
      {  
         LS = MathRound(LotSize*100*0.2)/100;        // Buy order, 20% of LotSize
         if(LS == 0) LS = 0.01;
         RefreshRates(); 
         ticket=OrderSend(Symbol(),OP_SELL,LS,Bid,slippage,SL,0,"20% order",801,0,CLR_NONE);
         if(ticket<=0)
            {
               error=GetLastError();
               Print("Error: ",ErrorDescription(error));
               if(error==134)      MessageBox("Account balance is too low!"); 
               else if(error==135) MessageBox("Prices have changed above the slippage!");
               else MessageBox("Error: "+ErrorDescription(error));
               return(0);         
            }
         OrderPrint(); 
         
         expiration = Time[0]+PERIOD_H4*60;
         diff = (High[1] - Bid)/Point;
         
         Price = Bid + (MathRound(diff*0.3))*Point;   //First pending order 30% higher         
         LS2 = MathRound(LotSize*100*0.4)/100;        // 40% of LotSize  
         if(LS2 == 0)
         {
            MessageBox("Account balance is too low!"); 
            return(0);
         }       
         while(true)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,LS2,Price,0,SL,0,"40% order 1",802,expiration,CLR_NONE);
            if(ticket<=0)
            {
              error=GetLastError();
              Print("Error = ",ErrorDescription(error));
              if(error==134)
              {   
                   MessageBox("Account balance is too low!"); 
                   return(0);
              }
              if(error==147)
              {
                 MessageBox("ACCESS TO TRADE EXPIRATION DENIED!"); 
                 return(0);
              }
              if(error==130)
              {
                 MessageBox("PENDING ORDER PRICE TO CLOSE!"); 
                 return(0);
              } 
            }
            else { Print("ticket = ",ticket); break; }
            //---- 2 seconds wait
            Sleep(2000);
         }
                  
         Price = Bid + (MathRound(diff*0.45))*Point;  //Second pending order 45% higher         
         LS3 = LotSize-LS-LS2;                        // rest of LotSize (~40%)
         TP1 = Bid - (MathRound(diff*0.8))*Point;     //TakeProfit set to 80% lower (this TP can cover all possible losses)
         if(LS3 < 0.01)
         {
            MessageBox("Account balance is too low!"); 
            return(0);
         }
         while(true)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,LS3,Price,0,SL,TP1,"40% order 2",803,expiration,CLR_NONE);
            if(ticket<=0)
            {
              error=GetLastError();
              Print("Error = ",ErrorDescription(error));
              if(error==134)
              {   
                   MessageBox("Account balance is too low!"); 
                   return(0);
              }
              if(error==147)
              {
                 MessageBox("ACCESS TO TRADE EXPIRATION DENIED!"); 
                 return(0);
              }
              if(error==130)
              {
                 MessageBox("PENDING ORDER PRICE TO CLOSE!"); 
                 return(0);
              } 
            }
            else { Print("ticket = ",ticket); break; }
            //---- 2 seconds wait
            Sleep(2000);
         }
         
         MessageBox("LotSize = "+LotSize+", 3 stages order","DONE");        
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+